﻿// #define THE_F
// #define V2
#define V3
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#if THE_F
class F<T> {
	public static string Value {
		get;
		set;
	}

	static F() {
		Console.WriteLine("F<{0}> class ctor called", typeof(T));
	}
}
#endif
class A {
	static A() {
		Console.WriteLine("A class ctor called ... setting F<A>.Value");
		F<A>.Value = "theA";
	}
}
class B {
	static B() {
		Console.WriteLine("B class ctor called ... setting F<B>.Value");
		F<B>.Value = "theB";
	}
}
class Program {
	static void Main(string[] args) {
		Console.WriteLine("Main starts ...");

		Console.WriteLine($"F<A>.Value == \"{F<A>.Value}\"");
		Console.WriteLine($"F<B>.Value == \"{F<B>.Value}\"");

		Console.WriteLine("Main ends ...");
	}
}

#if V2
class F<T> where T : new() {
	public static string Value {
		get;
		set;
	}

	static F() {
		Console.WriteLine("F<{0}> class ctor called", typeof(T));
		// force T class ctor
		new T();
	}
}
#endif

#if V3
class F<T> {
	public static string Value {
		get;
		set;
	}

	static F() {
		Console.WriteLine("F<{0}> class ctor called", typeof(T));
		// force T class ctor
		System.Runtime.CompilerServices.RuntimeHelpers.RunClassConstructor(typeof(T).TypeHandle);
	}
}
#endif